#include <math.h>
#include <values.h>
#include <stdio.h>
#include <stdlib.h>

#include "riemann.h"
#include "grid.h"
#include "heap.h"

void initHeap(void)
{
	index i;
	index nsqr = nmax*nmax;
	a = new struct heap[nsqr + 1];

	for(i = 0; i <= nsqr; i++){
		a[i].item = i;
		a[i].pathlength = MAXFLOAT;
		a[i].parent = NULL;

	}
	a[0].pathlength = 0.0;

	//le prime due righe devono essere modificate quando start non e' piu' 1
	//alla funzione deve essere passato il valore del nodo di partenza
	a[start].pathlength = 0.0;
	a[start].parent = start;

}

upHeap(index k)
{
	struct heap v;

	v = a[k];
	while(a[k/2].item <= v.item){
		a[k] = a[k/2];
		k = k/2;

	}
	a[k] = v;

	return 0;

}


ins(struct heap v)
{
	a[++N] = v;
	upHeap(N);

	return 0;

}

void downHeap(struct heap *a, index N, index k)
// consolida l'heap
// scambia elementi non ordinati secondo la lunghezza del path;
{
	int j;
	struct heap v;
	v = a[k];
	while(k <= N/2){
		j = k + k;
		if(j < N && a[j].pathlength < a[j+1].pathlength) j++;
		if(v.pathlength >= a[j].pathlength) break;
		// se i due elementi non sono ordinati vengono scambiati fra loro
		a[k] = a[j];

		k = j;

	}
	a[k] = v;

}


struct heap rem(index N)
// rimuove l'elemento in testa all'heap
// N = numero degli elementi nell'heap all'atto della chiamata
{
	struct heap v = a[1];
	a[1] = a[N];
	N--;
	downHeap(a, N, 1);
	return v;

}

void heapSort(struct heap a[], index N)
{
	int k;
	struct heap t;
	for(k = N/2; k >= 1; k--) downHeap(a, N, k);
	while(N > 1){
		t = a[1];
		grd[a[1].item].repr = N;
		a[1] = a[N];
      grd[a[N].item].repr = 1;
		a[N] = t;
		downHeap(a, --N, 1);


	}

}

index HeapSearch(index key, index nsqr)
// non serve assolutamente a nulla
{
	// ricerca key nell'array a[]
	// a partire dall'elemento a[1]
	index response;  	// valore restituito dalla funzione
	index signum;  	// segno per determinare il verso del
							// movimento sull'albero di ricerca
	index i, j, k;
			// i = indice di progressione parte da nsqr;
			// j = indice dell'elemento di a puntato;
			// k = risultato del confronto;

	response = 0;
	i = 2*(nsqr/2); j = 1;
	if(nsqr%2 != 0){ // considera l'ultimo elemento
		if(a[nsqr].item == key){
			response = nsqr;
			i = 0; // determina la condizione di non ingresso nel ciclo while

		}

	}
	// considera il primo elemento

	k = (a[1].item - key);
	if(k == 0){
		response = 1;
		i = 0;

	}

	else{
		if(a[1].item < key){ // prepara per ingresso nel while
			i = i/2;
			j = j + i;

		}
		else i = 0;

	}

	while(i != 0){
		k = (a[j].item - key);
		if(k != 0){
			if(a[j].item < key) signum = 1;
			else signum = -1;
			i = i/2;
			j = j + signum*i;

		}
		else{
			response = j;
			break;

		}

	}
	return response;

}

