#define TRUE = -1
#define FALSE = 0

typedef unsigned int index;

extern index nmax;
extern int regions;
extern int N;
extern index nheap;

// get data from file

void getGridFromFile(const char *filename);
void RecastGrid(void);
void getMetricTensorFromFile(const char *filename);

// the metric tensor
struct metrictensor{
	float xx;
	float xy;
	float yy;
};

void initMetricTensor(void);

// la griglia associata al dominio:() dovra' essere inserita in un modulo a parte
// metric indica la metrica in vigore sul nodo considerato
// pathmark indica se il cammino passa per il nodo
// parent indica qual'e' il nodo che precede quello considerato
// repr indica se il nodo ha qualche rappresentante nell'heap

struct grid{
	index metric;
	index pathmark;
	index parent;
	index repr;
	float pathlength;

};

void initGrid(void);
void getGridFromFile(const char *);
void getNeighbours(struct heap *a, index nsqr);
float getArcLength(unsigned long vert1, unsigned long vert2);
struct node *insertAfter(index item, float pathlength, struct node *t);

// l'heap associato alla parte inesplorata del grafo
// item: elemento della griglia
// pathlength lunghezza del path passante per item
// parent puntatore al nodo precedente

// lo stack per l'esame dei vicini di un nodo


extern index start;

extern struct grid *grd;
extern struct metrictensor *metrictensor;
extern struct heap *a;
extern struct paraHeap *b;
extern struct stack *head, *z, *t; //stack

index GetStart(void);
index GetGoal(void);
void WriteAuthorsOnScreen();
void WriteGridOnScreen(void);
void WriteGridIndexesOnScreen();
void BackSearch(index start, index goal);
void WriteResultOnScreen(void);