#include <conio.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <dos.h>

#include "riemann.h"
#include "metric.h"
#include "grid.h"
#include "heap.h"
#include "stack.h"

index nmax;
index regions;
int N;
index nsqr;
struct grid *grd;
struct metrictensor *metrictensor;
struct heap *a;
struct stack *head, *z, *t; //stack
index start, goal;

void IncrementaStack(index i, index buf, index nsqr)
// esamina se il nodo sia stato esplorato se si grd[buf].repr == 0
// per i nodi inesplorati calcola la lunghezza d'arco
// e spinge i valori calcolati nello stack
{
	float arclength;

	if(grd[buf].repr != 0){
		arclength = getArcLength(i,buf);
		push(buf, arclength);

	}

}

void getNeighbours(struct heap *a, index nsqr)
// assegnato un elemento dell'heap
// ne ricerca i potenziali vicini
{
	index i, buf;

	ldiv_t lx;

	i = a->item;

	lx = ldiv(i,nmax);

	//CALCOLO DEI PRIMI VICINI

	// RowShift = +1

	// Superiori (Per Elementi al di sotto della Prima Riga)
	if(i > nmax)
	{
		// ColShift = 0
		buf = i - nmax;
		IncrementaStack(i, buf, nsqr);

		// ColShift = -1
		if(lx.rem != 1) // Non nella Prima Colonna
		{
			buf = i - nmax -1;
			IncrementaStack(i, buf, nsqr);

		}

		// ColShift = 1
		if(lx.rem != 0)  // Not in Last Column
		{
			buf = i - nmax + 1;
			IncrementaStack(i, buf, nsqr);

		}

	}

	//RowShift = 0

	// ColShift = -1
	if(lx.rem != 1)  // Not in First Column
	{
		buf = i - 1;
		IncrementaStack(i, buf, nsqr);

	}
	// ColShift = 1
	if(lx.rem != 0) //Not in Last Column
	{
		buf = i + 1;
		IncrementaStack(i, buf, nsqr);

	}

	// RowShift = -1

	// Lower (Elements Over Last Row)
	if(i + nmax <= (nmax*nmax))
	{
		// ColShift = 0
		buf = i + nmax;
		IncrementaStack(i, buf, nsqr);

		// ColShift = -1
		if(lx.rem != 1) // Not in First Column
		{
			buf = i + nmax -1;
			IncrementaStack(i, buf, nsqr);

		}

		// ColShift = 1
		if(lx.rem != 0) // Not in Last Column
		{
			buf = i + nmax + 1;
			IncrementaStack(i, buf, nsqr);

		}

	}
	//SECOND NEIGHBOURS

	// RowShift = 2

	//Superiori (Elementi al di sotto della seconda riga)
	if(i > 2*nmax)
	{

		// ColShift = -1
		if(lx.rem != 1) // Not in First Column
		{
			buf = i - 2*nmax - 1;
			IncrementaStack(i, buf, nsqr);

		}

		// ColShift = 1
		if(lx.rem != 0)
		{
			buf = i - 2*nmax + 1;
			IncrementaStack(i, buf, nsqr);

		}

	}

	// RowShift = 1

	// Superiori Bassi (per elementi al di sotto della prima riga)
	if(i > nmax)
	{
		// ColShift = -1
		if(lx.rem > 2 || lx.rem == 0) // Beyond Second Column
		{
			buf = i - nmax - 2;
			IncrementaStack(i, buf, nsqr);

		}

		// ColShift = 1
		if(lx.rem < (nmax - 1) && lx.rem != 0)
		{
			buf = i - nmax + 2;
			IncrementaStack(i, buf, nsqr);

		}

	}
	// RowShift = -1

	// Inferiori Alti (per elementi al di sopra della penultima riga)
	if(i + (2*nmax) <= nmax*nmax)
	{

		// ColShift = -1
		if(lx.rem != 1) // Non nella prima colonna
		{
			buf = i + 2*nmax - 1;
			IncrementaStack(i, buf, nsqr);
		}

		// ColShift = 1
		if(lx.rem != 0) // Non nell'Ultima Colonna     SCAGLIATO!!!
		{
			buf = i + 2*nmax + 1;
			IncrementaStack(i, buf, nsqr);

		}

	}

	// RowShift = -2

	// Down Lower (Elements Over Last Row)
	if(i + nmax <= nmax*nmax)
	{
		// ColShift = -1
		if(lx.rem > 2 || lx.rem == 0) // a destra della seconda colonna
		{
			buf = i + nmax - 2;
			IncrementaStack(i, buf, nsqr);

		}

		// ColShift = 1
		if(lx.rem < (nmax - 1) && lx.rem != 0) // a sinistra della penultima colonna
		{
			buf = i + nmax + 2;
			IncrementaStack(i, buf, nsqr);

		}

	}

	//CALCOLO  DEI TERZI VICINI

	// RowShift = 3

	if(i > 3*nmax) // sotto la terza riga
	{
		// ColShift = -1
		if(lx.rem != 1) // a destra della prima colonna
		{
			buf = i - 3*nmax - 1;
			IncrementaStack(i, buf, nsqr);

			//ColShift = -2
			if(lx.rem > 2 || lx.rem == 0) // a destra della seconda colonna
			{
				buf = i - 3*nmax - 2;
				IncrementaStack(i, buf, nsqr);

			}

		}

		//  ColShift = 1
		if(lx.rem != 0) // a sinistra dell'ultima colonna
		{
			buf = i - 3*nmax + 1;
			IncrementaStack(i, buf, nsqr);

			// ColShift = 2
			if(lx.rem != 0 && lx.rem < (nmax -1)) // a sinistra della penultima colunna
			{
				buf = i - 3*nmax + 2;
				IncrementaStack(i, buf, nsqr);

			}

		}

	}

	// RowShift = 2
	if(i + (3*nmax) <= nmax*nmax)
	{
		// ColShift = -1
		if(lx.rem != 1)
		{
			buf = i + 3*nmax - 1;
			IncrementaStack(i, buf, nsqr);

			// ColShift = -2
			if(lx.rem > 2 || lx.rem == 0)
			{
				buf = i + 3*nmax - 2;
				IncrementaStack(i, buf, nsqr);

			}

		}

		// ColShift = 1
		if(lx.rem != 0)
		{
			buf = i + 3*nmax + 1;
			IncrementaStack(i, buf, nsqr);

			// ColShift = 2
			if(lx.rem != 0 && lx.rem < (nmax - 1))
			{
				buf = i + 3*nmax + 2;
				IncrementaStack(i, buf, nsqr);

			}

		}

	}

	// RowShift = 2
	if(i > 2*nmax) //problemi
	{
		if(lx.rem > 3 || (lx.rem == 0 && nmax > 3)) // a destra della terza colonna
		{
			buf = i - 2*nmax - 3;
			IncrementaStack(i, buf, nsqr);

			buf = i - nmax - 3;
			IncrementaStack(i, buf, nsqr);

		}

		if(lx.rem < (nmax - 2) && lx.rem != 0)
		{
			buf = i - 2*nmax + 3;
			IncrementaStack(i, buf, nsqr);

			buf = i - nmax + 3;
			IncrementaStack(i, buf, nsqr);
		}

	}

	if(i + 2*nmax < nmax*nmax)
	{
		if(lx.rem > 3 || lx.rem == 0)
		{
			buf = i + 2*nmax - 3;
			IncrementaStack(i, buf, nsqr);

			buf = i + nmax - 3;
			IncrementaStack(i, buf, nsqr);

		}

		if(lx.rem < (nmax - 2) && lx.rem != 0)
		{
			buf = i + 2*nmax + 3;
			IncrementaStack(i, buf, nsqr);

			buf = i + nmax + 3;
			IncrementaStack(i, buf, nsqr);
		}

	}
}

float getArcLength(index vert1, index vert2)
{

 long  a1, a2;
 float buf, lc, x, y, z, b1, b2, pa, qa, delta;


	// SetMetricTensor(i,x,y,z); definire con il codice seguente
	x = metrictensor[grd[vert2].metric].xx;
	y = metrictensor[grd[vert2].metric].xy;
	z = metrictensor[grd[vert2].metric].yy;


	if(vert2 == vert1 - 1) {a1 = -1; a2 =  0; lc =  1;} // scagliato
	else if(vert2 == vert1 + 1) {a1 =  1; a2 =  0; lc =  1;}
	else if(vert2 == vert1 - nmax) {a1 =  0; a2 =  1; lc =  1;}
	else if(vert2 == vert1 + nmax) {a1 =  0; a2 = -1; lc =  1;}
	else if(vert2 == vert1 - nmax + 1) {a1 =  1; a2 =  1; lc = sqrt(2);}
	else if(vert2 == vert1 + nmax - 1) {a1 = -1; a2 = -1; lc = sqrt(2);}
	else if(vert2 == vert1 - nmax - 1) {a1 = -1; a2 =  1; lc = sqrt(2);}
	else if(vert2 == vert1 + nmax + 1) {a1 =  1; a2 = -1; lc = sqrt(2);}
	else if(vert2 == vert1 - 2*nmax + 1) {a1 =  1; a2 =  2; lc = sqrt(5);}
	else if(vert2 == vert1 + 2*nmax - 1) {a1 =  1; a2 = -2; lc = sqrt(5);}
	else if(vert2 == vert1 + 2*nmax + 1) {a1 =  1; a2 = -2; lc = sqrt(5);}
	else if(vert2 == vert1 - 2*nmax - 1) {a1 =  1; a2 =  2; lc = sqrt(5);}
	else if(vert2 == vert1 - nmax + 2) {a1 =  2; a2 =  1; lc = sqrt(5);}
	else if(vert2 == vert1 + nmax - 2) {a1 = -2; a2 = -1; lc = sqrt(5);}
	else if(vert2 == vert1 + nmax + 2) {a1 =  2; a2 = -1; lc = sqrt(5);}
	else if(vert2 == vert1 - nmax - 2) {a1 = -2; a2 =  1; lc = sqrt(5);}
	else if(vert2 == vert1 - 3*nmax + 1) {a1 =  1; a2 =  3; lc = sqrt(10);}
	else if(vert2 == vert1 + 3*nmax - 1) {a1 = -1; a2 = -3; lc = sqrt(10);}
	else if(vert2 == vert1 - 3*nmax + 2) {a1 =  2; a2 =  3; lc = sqrt(13);}
	else if(vert2 == vert1 + 3*nmax - 2) {a1 = -2; a2 = -3; lc = sqrt(13);}
	else if(vert2 == vert1 - 3*nmax - 2) {a1 = -2; a2 =  3; lc = sqrt(13);}
	else if(vert2 == vert1 + 3*nmax + 2) {a1 =  2; a2 = -3; lc = sqrt(13);}
	else if(vert2 == vert1 - 3*nmax - 1) {a1 = -1; a2 =  3; lc = sqrt(10);}
	else if(vert2 == vert1 + 3*nmax + 1) {a1 =  1; a2 = -3; lc = sqrt(10);}
	else if(vert2 == vert1 - 2*nmax - 3) {a1 = -3; a2 =  2; lc = sqrt(13);}
	else if(vert2 == vert1 + 2*nmax + 3) {a1 =  3; a2 = -2; lc = sqrt(13);}
	else if(vert2 == vert1 - 2*nmax + 3) {a1 =  3; a2 =  2; lc = sqrt(13);}
	else if(vert2 == vert1 + 2*nmax - 3) {a1 = -3; a2 = -2; lc = sqrt(13);}
	else if(vert2 == vert1 - nmax + 3) {a1 =  3; a2 =  1; lc = sqrt(10);}
	else if(vert2 == vert1 + nmax - 3) {a1 = -3; a2 = -1; lc = sqrt(10);}
	else if(vert2 == vert1 - nmax - 3) {a1 = -3; a2 =  1; lc = sqrt(10);}
	else if(vert2 == vert1 + nmax + 3) {a1 =  3; a2 =  1; lc = sqrt(10);}

	if(a1 == 1 && a2 == 0){
		b1 = 1; b2 = 0;

	}
	else{
		pa = a1/lc;
		qa = a2/lc;
		b1 = qa/sqrt(2*(1 - pa));
		b2 = sqrt((1 - pa)/2);

	}

	delta = (b1*b1)*x + 2*b1*b2*y + b2*b2*z;

	if(delta >= 0) buf = lc*sqrt(delta);
	else buf = (-1)*lc*sqrt(abs(delta));

	return buf;

}

int main(void)
{
 textbackground(RED);
 WriteAuthorsOnScreen();
 delay(2000);
 clrscr();
 char continua;
 continua = 's';
 while(continua == 's'){
	 textbackground(BLUE);
	 clrscr();
	 initGrid();			// inizializza la griglia dei nodi
	 if(nmax <= 15){
		WriteGridOnScreen();// visualizza la griglia dei nodi
		clrscr();
		WriteGridIndexesOnScreen();

	 }
	 nsqr = nmax*nmax;
	 start = GetNode("introdurre il nodo di partenza", 1, nsqr); // nodo di partenza
	 goal = GetNode("introdurre il nodo di arrivo", 1, nsqr); 	// nodo di arrivo
	 RecastGrid();       // risistemazione dei parametri della griglia
	 initMetricTensor(); // inizializza il tensore metrico
	 initHeap();			// inizializza l'heap
	 stackInit();        // inizializza lo stack

	 float pathlength;
	 while(nsqr > 0){
		getNeighbours(&a[1],nsqr);
		while(!stackEmpty()){
			struct stack *stacktop = pop();
			pathlength = a[1].pathlength + stacktop->arclength;
			if(grd[stacktop->item].pathlength > pathlength){
				grd[stacktop->item].pathlength = pathlength;
				grd[stacktop->item].parent = a[1].item;

				a[grd[stacktop->item].repr].pathlength = pathlength;

			}

		}
		grd[a[1].item].repr = 0;

		rem(nsqr); 				// rimuove il primo elemento dell'heap
		nsqr--;					// decrementa il numero di elementi dell'heap
		heapSort(a, nsqr);	// riordina l'heap

	 }


	 BackSearch(start, goal);
	 // WriteResultonFile();
	 WriteResultOnScreen();
	 getch();
	 textbackground(BLACK);
	 clrscr();
	 window(34,10,44,10);
	 textbackground(BLUE);
	 _setcursortype(_NOCURSOR);
	 clrscr();
	 cprintf("continua ?");
	 continua = getch();
	 _setcursortype(_NORMALCURSOR);


 }

 textbackground(BLACK);
 clrscr();
 return 0;

}

void BackSearch(index start, index goal)
{
	index item;
	item = goal;
	do{
		grd[item].pathmark = 1;
		item = grd[item].parent;

	}while(item != start);
	grd[start].pathmark = 1;

}

void WriteResultOnFile(const char *filename = "RIEMANN.RSX")
{
	FILE *outfile = fopen(filename,"w");
	index i, j, k;
	clrscr(); 								// pulisce lo schermo
	for(i = 0; i < nmax; i++){ 		// disegna righe
		for(j = 1; j <= nmax; j++){  	// disegna colonne
			k = i*nmax + j;
			fprintf(outfile,"%d ", grd[k].pathmark);

		}
		printf("\n");

	}
}

void WriteAuthorsOnScreen()
{
 clrscr();
 puts("  Metodi Riemanniani su Algoritmi di Calcolo di Cammini Minimi\n");
 puts("  Massimo FERRI: Dip. di Matematica Universita'degli Studi di Bologna");
 puts("  \t\t Piazza Porta S.Donato, 5 - 40127 - Bologna");
 puts("  \t\t Tel. 051/354452 - Fax 059/354490");
 puts("  \t\t E-mail ferri@dm.unibo.it\n");
 puts("  Luca COSTA:\t Alya Automazione S.r.l.");
 puts("  \t\t via B. Croce,20 - 41100 - Modena");
 puts("  \t\t Tel. 059/452162 - Fax 059/452403");
 puts("  \t\t E-mail costa@cariddi.unimo.it\n");


}

void WriteGridOnScreen()
// rappresenta l'output sullo schermo
{
	index i, j, k;
	window(1,1,80,25);
	clrscr(); 								// pulisce lo schermo
	cputs("Griglia dei nodi: \r\n");
	for(i = 0; i < nmax; i++){ 		// disegna righe
		gotoxy(1,i+3);
		for(j = 1; j <= nmax; j++){  	// disegna colonne
			k = i*nmax + j;
			cprintf("%d ", grd[k].metric);

		}
		cprintf("\r\n");

	}
	puts("un tasto qualsiasi per continuare...\r\n");
	getch();


}

void WriteGridIndexesOnScreen()
// rappresenta l'output sullo schermo
{
	index i, j, k;
	window(1,1,80,25);
	char *spc;
	cputs("Griglia degli indici: \r\n");
	for(i = 0; i < nmax; i++){ 		// disegna righe
		gotoxy(1,i+3);
		for(j = 1; j <= nmax; j++){  	// disegna colonne
			k = i*nmax + j;
			if(k < 10) spc = "  ";
			else if( k >= 10 && k < 100) spc = " ";
			else if( k >= 100 && k < 1000) spc = "";
			cprintf("%s%d ", spc, k);

		}
		cprintf("\r\n");

	}
	puts("un tasto qualsiasi per continuare...\r\n");
	getch();

}

void WriteResultOnScreen()
// rappresenta l'output sullo schermo
{
	index i, j, k;
	window(1,1,80,25);
	clrscr(); // pulisce lo schermo

	puts("Risultato: ");
	printf("numero nodi:\t%d\nstart:\t\t%d\ngoal:\t\t%d\nLunghezza Cammino:\t%f\n\n", nmax*nmax, start, goal, grd[goal].pathlength);
	for(i = 0; i < nmax; i++){ 		// disegna righe
		for(j = 1; j <= nmax; j++){  	// disegna colonne
			k = i*nmax + j;
			printf("%d ", grd[k].pathmark);

		}
		printf("\n");

	}

}

index GetNode(char *message, index first, index last)
//input del nodo tra firs e last
{
	index node;
	int xcur, ycur;
	xcur = wherex();
	ycur = wherey();
	node = 0;
	while(node < first || node > last){
		gotoxy(xcur,ycur);
		printf("%s :", message);
		_setcursortype(_SOLIDCURSOR);
		scanf("%d", &node);

	}
	_setcursortype(_NORMALCURSOR);

	return node;
}